#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_reduce_partial4xi.py">
#<abstract4xi abstract = "providing function _reduce_partial4xi"/>
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['_reduce_partial4xi']  
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # winapi
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
from pickle import _Pickler as Pickler

try:
    from functools import partial
except ImportError:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing import forking
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from _rebuild_partial4xi import _rebuild_partial4xi
from forkingpickler4xi import ForkingPickler4Xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -----------------------------------------------------------------------------------------    
#<function4xi function = "reduce-partial4xi" usage = "
#   forking.py
#       ForkingPickler.register(partial, _reduce_partial)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------        
 
def _reduce_partial4xi(p):
    '''
    reduces partial
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    class2print = "_reduce_partial4xi"
    method2print = "_reduce_partial4xi"
  

    message2print = "{started" + "; reduce-partial4xi-started: " + str(_reduce_partial4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    message2print = "{passed" + "; program-passed-to-reduce-partial4xi: " + str(p) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
           
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; program-func-passing-to-rebuild-partial4xi-by-reduce-partial4xi: " + str(p.func) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    message2print = "{passing" + "; program-args-passing-to-rebuild-partial4xi-by-reduce-partial4xi: " + str(p.args) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
           
    message2print = "{passing" + "; program-keywords-passing-to-rebuild-partial4xi-by-reduce-partial4xi: " + str(p.keywords or {}) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    message2print = "{returning" + "; rebuild-partial4xi-function-returning-by-reduce-partial4xi: " + str(_rebuild_partial4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
                      
       
    return _rebuild_partial4xi, (p.func, p.args, p.keywords or {})
  
#</function4xi>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ForkingPickler4Xi.register(partial, _reduce_partial4xi)
#"
#"/>

#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_reduce_partial4xi.txt
#   sense-test-reduce-partial4xi.xml
#   reason-test-reduce-partial4xi.xml
#   ace-test-reduce-partial4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _reduce_partial4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
